package jp.kirikiri.tvp2.base;

import jp.kirikiri.tjs2.TJSException;

public abstract class BaseInputEvent implements Runnable {

	protected static int InputEventTagMax;
	public static void initialize() {
		InputEventTagMax = 0;
	}

	private Object mSource;
	private int mTag;
	public BaseInputEvent( Object source, int tag) {
		mSource = source;
		mTag = tag;
	}

	public Object getSource() { return mSource; }
	public int getTag() { return mTag; }

	abstract public void deliver() throws TJSException;
	@Override
	public void run() {
		try {
			deliver();
		} catch (TJSException e) {
		}
	}
	// void deliver() を run() に実装すること

}
